﻿@{
    ViewData["Title"] = "Client List";
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="datatable datatable-bordered" id="firm_list"></div>
        </div>
    </div>
</div>
<div class="modal" id="AdviserModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<div class="modal" id="ClientModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<script id="move-template" type="text/html">
    <tr class="datatable-row">
        <td class="datatable-cell p-0" style="position: absolute; z-index: 1; left: 60px;">
            <div class="d-flex align-items-center p-3 bg-light-warning border border-warning" id="migrate-client-container" style="box-shadow: 0px 5px 10px rgba(5, 4, 33, 0.3); border-radius: 4px;width:fit-content">
                <div class="mr-5">
                    <select class="form-control form-control-sm select2" id="adviser-list-drp" style="width:200px" data-placeholder="-Select-" data-search-placeholder="Search">
                        <option></option>
                    </select>
                </div>
                <button type="button" class="btn btn-sm btn-warning" style="padding: 0.40rem 1rem; color: #fff" id="migrate-btn" disabled>
                    <img src="~/images/move-icon.png" height="18" class="mr-2" />
                    <span style="font-size: 14px; vertical-align: bottom;">Move</span>
                </button>
                <div class="ml-3" id="selectedRecords">
                    <input type="checkbox" id="selectedAll" class="d-none" />
                    <span>
                        <span id="onPageRecords">All </span><span id="selectedRowsCount"></span> records are selected.
                    </span>
                </div>
                <a id="selectedAllRecords" href="javascript:" class="btn btn-sm btn-white btn-square btn-hover-light-dark font-weight-bold ml-3">
                    <span id="selectAll">
                        Select all <span id="totalRowsCount"></span> records
                    </span>
                    <span id="clearSelection" class="d-none">
                        Clear Selection
                    </span>
                </a>
            </div>
        </td>
    </tr>
</script>
@section scripts{
    <script>
        var firmId;
        var sourceUserId;
        var clientTable = function (e) {
            checkedIds = [];
            sourceUserId = e.data.id;
            var ktDataTablOptions = ktDataTableDefaultConfigOptions;
            ktDataTablOptions.source = `admin/adviser/fetchclients?userId=${e.data.id}`;
            window['adviser_sub_datatable_' + e.data.id] = $('<div/>').attr('id', `adviser_list_${e.data.id}`).appendTo(e.detailCell).KTDatatable({
                data: ktDataTablOptions,
                columnFilter: true,
                columns: [
                    { field: '', title: '', sortable: false, width: 20, textAlign: 'center', selector: {}, template: function (row) { return row.id; } },
                    { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                    {
                        field: 'clientData.name', title: 'Client Name/Email', sortable: 'asc', width: 390, filter: { container: "ClientName" },
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var isClientDOBSetupCompleted = row.clientData.dateOfBirth != null && new Date(row.clientData.dateOfBirth).getFullYear() != 1;
                            var ocupations = row.clientOccupations;
                            var clientOcupations = ocupations.filter(m => m.employmentOf == ClientType.CLIENT);
                            var isMarried = row.clientData.dateOfCurrentMarriage != null && new Date(row.clientData.dateOfCurrentMarriage).getFullYear() != 1 && row.clientData.maritalStatus == MaritalStatus.MARRIED;
                            var isSpouseDOBSetupCompleted = row.spouseData != null && row.spouseData.dateOfBirth != null && new Date(row.spouseData.dateOfBirth).getFullYear() != 1;
                            var isCompletedProfile = isSetupCompleted && row.clientData.surveyCompleted && isClientDOBSetupCompleted && clientOcupations.length > 0;
                            if (isMarried)
                                isCompletedProfile = isCompletedProfile && isSpouseDOBSetupCompleted;
                            var initial = [row.clientData.firstName, row.clientData.lastName].map((n) => n[0]).join("").substring(0, 2);
                            var color = getRandomColor();
                            var tooltipHtml = "Pending Items To Complete";
                            tooltipHtml += "<ul>";
                            if (!isSetupCompleted)
                                tooltipHtml += `<li>Complete the Password setup process</li>`;
                            if (!row.initialProfileSetupCompleted)
                                tooltipHtml += `<li>Mention at least one Planning Area</li>`;
                            if (!isClientDOBSetupCompleted)
                                tooltipHtml += `<li>Mention Client's Date of Birth</li>`;
                            if (isMarried && !isSpouseDOBSetupCompleted)
                                tooltipHtml += `<li>Mention Spouse's Date of Birth</li>`;
                            if (row.clientOccupations) {
                                var spouseOcupations = ocupations.filter(m => m.employmentOf == ClientType.SPOUSE);
                                if (clientOcupations == 0)
                                    tooltipHtml += `<li>Mention at least one Client's employment (if not Retired or Homemaker)</li>`;
                                if (isMarried && spouseOcupations == 0)
                                    tooltipHtml += `<li>Mention at least one Spouse's employment (if not Retired or Homemaker)</li>`;
                            }
                            if (!row.clientData.surveyCompleted)
                                tooltipHtml += `<li>Complete the survey</li>`;
                            tooltipHtml += "</ul>";
                            var warningHtml = !isCompletedProfile ? `<span class="fa-stack pulse pulse-warning" data-toggle="tooltip" data-html="true" data-original-title="${tooltipHtml}" data-placement="right" role="button">
                                                                    <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                                    <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                                    <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                                    </span>` : '';
                            return `<div class="d-flex align-items-center">
                                                                    <div class="symbol symbol-40 flex-shrink-0">
                                                                    <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                                    </div>
                                                                    <div class="ml-2">
                                                                    <div class="text-dark-75 font-weight-bold line-height-sm">${row.clientData.name}</div>
                                                                    <div class="text-primary">${row.username}</div>
                                                                    </div>
                                                                    ${warningHtml}
                                                                    </div>`;
                        }
                    },
                    {
                        field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 110,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.setupCompletedDate)
                        },
                    },
                    {
                        field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.lastLogin)
                        }
                    },
                    {
                        field: 'actions', title: 'Actions', width: 160, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var tz = new Date().getTimezoneOffset();
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var isClientDOBSetupCompleted = row.clientData.dateOfBirth != null && new Date(row.clientData.dateOfBirth).getFullYear() != 1;
                            var ocupations = row.clientOccupations;
                            var clientOcupations = ocupations.filter(m => m.employmentOf == ClientType.CLIENT);
                            var isCompletedProfile = isSetupCompleted && isClientDOBSetupCompleted;
                            var spouseRiskArcHtml = row.clientData.dateOfCurrentMarriage != null && new Date(row.clientData.dateOfCurrentMarriage).getFullYear() != 1 && row.clientData.maritalStatus == MaritalStatus.MARRIED && row.spouseData != null ?
                                `<li class="navi-item">
                                                <a href="report/risk-arc?token=${encodeURIComponent(row.encryptedGuid)}&tz=${tz}&clientType=${ClientType.SPOUSE}" data-id="${row.id}" class="navi-link" target="_blank"><span class="navi-text">Spouse's RiskArc</span></a>
                                                </li>` : "";
                            var viewProfileHtml = isSetupCompleted ? `<a class="ml-1" href="admin/account/clientlogin?guid=${row.guid}" target="_blank" data-toggle="tooltip" data-original-title="View Profile">
                                                <img src="/images/view-profile.png" height="30" />
                                                </a>` : "";
                            var resendHtml = !isSetupCompleted ? `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.CLIENT},'${row.guid}')">
                                                <img src="/images/email-resend-icon.png" height="25" />
                                                <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 63px;top: 29px;"></i>
                                                </button>`: "";
                            var arcOfLifeHtml = row.initialProfileSetupCompleted && isCompletedProfile && clientOcupations.length > 0 ?
                                `<li class="navi-item">
                                    <a href="report/arc-of-life?token=${encodeURIComponent(row.encryptedGuid)}&tz=${tz}" data-id="${row.id}" class="navi-link" target="_blank"><span class="navi-text">Arc Of Life</span></a>
                                 </li>
                                 <li class="navi-item">
                                    <a href="report/balance-sheet?token=${encodeURIComponent(row.encryptedGuid)}" class="navi-link" target="_blank"><span class="navi-text">Balance Sheet</span></a>
                                 </li>` : "";
                            var reportHtml = isCompletedProfile ?
                                `<div class="dropdown dropdown-inline" data-toggle="tooltip" data-original-title="View Reports">
                                    <button class="btn btn-sm btn-icon action-menu" data-toggle="dropdown" aria-expanded="false" id="report-icon-${row.id}" style="margin-left: -3px">
                                        <i class="fas fa-file-alt icon-2x text-primary mr-0" aria-hidden="true"></i>
                                    </button>
                                    <span class="fa-stack fa-1x mt-2 d-none" id="loader-icon-${row.id}">
                                        <i class="fas fa-box-open fa-stack-2x text-primary icon-xl"></i>
                                        <i class="fas fa-arrow-down fa-stack-1x icon-nm text-warning faa-falling animated" style="top:-15px;"></i>
                                    </span>
                                    <div class="dropdown-menu dropdown-menu-sm dropdown-menu-right report-menu">
                                        <ul class="navi flex-column navi-hover py-2">
                                            <li class="navi-item">
                                                <a href="report/personal-canvas?token=${encodeURIComponent(row.encryptedGuid)}&tz=${tz}" data-id="${row.id}" class="navi-link" target="_blank"><span class="navi-text">My Personal Canvas</span></a>
                                            </li>
                                            <li class="navi-item">
                                                <a href="report/risk-arc?token=${encodeURIComponent(row.encryptedGuid)}&tz=${tz}&clientType=${ClientType.CLIENT}" data-id="${row.id}" class="navi-link" target="_blank"><span class="navi-text">Client's RiskArc</span></a>
                                            </li>
                                            ${spouseRiskArcHtml}
                                            ${arcOfLifeHtml}
                                        </ul>
                                    </div>
                                 </div>`: "";
                            return `<button class="btn btn-icon btn-icon btn-sm btn-client-edit mr-2" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                <img src="/images/edit-icon.png" height="25" />
                                                </button>
                                                ${resendHtml}
                                                ${viewProfileHtml}
                                                ${reportHtml}`;
                        },
                    }
                ],
            })
        }
        var adviserTable = function (e) {
            firmId = e.data.id;
            var ktDataTablOptions2 = ktDataTableDefaultConfigOptions;
            ktDataTablOptions2.source = `admin/adviser/fetchadviserswithcount?firmId=${e.data.id}`;
            window['sub_datatable_' + e.data.id] = $('<div/>').attr('id', `firm_list_${e.data.id}`).appendTo(e.detailCell).KTDatatable({
                data: ktDataTablOptions2,
                columnFilter: true,
                columns: [
                    { field: 'id', title: '', sortable: false, width: 0 },
                    {
                        field: 'name', title: 'Adviser Name', sortable: 'asc', filter: { container: "AdviserName" },
                        template: function (row) {
                            return `<div class="font-size-lg">${row.name}</div>`
                        }
                    },
                    {
                        field: 'username', title: 'Username', width: 300, filter: {},
                        template: function (row) {
                            return `<div class="font-size-lg">${row.username}</div>`
                        }
                    },
                    {
                        field: 'totalClient', title: '', textAlign: 'right', sortable: false,
                        template: function (row) {
                            return `<span class="label label-lg label-danger">${row.totalClient}</span>`
                        }
                    },
                ],
                detail: { content: clientTable }
            })
        }
        bindFirmsGrid("Adviser", adviserTable);
        $(document).on("click", ".btn-client-edit", function (e) {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`adviser/home/addclient?guid=${guid}`, "ClientModal");
            setTimeout(function () { KTApp.unblockPage(); }, 1000);
            $("#ClientModal").modal({ backdrop: 'static' });
        });
        var checkedIds = [];
        $(document).on('datatable-on-check datatable-on-uncheck', "[id^=adviser_list]", function (e) {
            var el = $(e.target);
            el.find("th .checkbox-all").addClass("checkbox-outline");
            var dt = el.KTDatatable();
            checkedIds = getCheckedIds(dt);
            var checkedCheckbox = checkedIds.length;
            if ($("#migrate-client-container").length == 0 && checkedCheckbox > 0) {
                el.find("thead:first").prepend($("#move-template").html());
                $("#adviser-list-drp").select2({
                    ajax: {
                        url: `admin/adviser/GetAdvisers?firmId=${firmId}&ownerId=${sourceUserId}`,
                        data: function (params) {
                            return { term: params.term, page: params.page || 1 };
                        },
                        processResults: function (data, params) {
                            params.page = params.page || 1;
                            return {
                                results: data.items,
                                pagination: {
                                    more: (params.page * 10) < data.totalCount
                                }
                            };
                        }
                    }
                }).on("change", function () {
                    hasAdviserId = $(this).val() > 0;
                    $("#migrate-btn").prop("disabled", !hasAdviserId)
                });
            }
            if (checkedCheckbox == 0) $("#migrate-client-container").closest("tr").remove();
            $("#selectedRowsCount").text(checkedCheckbox);
            var totalRows = dt.getTotalRows();
            $("#totalRowsCount").text(totalRows);
            var pagination = dt.getDataSourceParam("pagination");
            var checkedAll = el.find("th .checkbox-all input[type='checkbox']").is(":checked");
            var cls = pagination.pages > 1 && checkedAll ? "" : "d-none";
            $("#selectedRecords").removeClass("d-none");
            $("#selectedAllRecords").removeClass("d-none");
            $("#selectedRecords").addClass(cls);
            $("#selectedAllRecords").addClass(cls);
            var allChecked = checkedIds.length == totalRows;
            if (allChecked) {
                el.find("#selectedAll").prop('checked', allChecked);
                el.find("th .checkbox").removeClass("checkbox-outline")
            }
            if (checkedCheckbox == pagination.total) {
                $("#clearSelection").removeClass("d-none");
                $("#selectAll").addClass("d-none");
                $("#onPageRecords").removeClass("d-none");
            }
            else {
                $("#clearSelection").addClass("d-none");
                $("#selectAll").removeClass("d-none");
                $("#onPageRecords").addClass("d-none");
            }
        });
        $(document).on("datatable-on-ajax-done", "[id^=adviser_list]", function (e) {
            var el = $(e.target);
            setTimeout(function () {
                if (checkedIds) {
                    $.each(checkedIds, function (i, val) {
                        $(`input[value='${val}']`).prop('checked', true);
                    });
                }
                setActiveCheckBox(el, function () {
                    var checkedAll = el.find("#selectedAll").is(":checked");
                    if (checkedAll)
                        el.find(`input[type='checkbox']`).prop('checked', true)
                });
            }, 0);
        })
        $('body').click(function (event) {
            if (!$(event.target).closest("[id^=adviser_list]").length
                && !$(event.target).closest(".select2-search__field").length
                && !$(event.target).closest(".select2-results").length
                && !$(event.target).closest(".select2-search").length)
                $("#migrate-client-container").closest("tr").remove();
        });
        var moveClients = function (checkedIds, userId, sourceUserId, isAllChecked) {
            $.post("admin/superadmin/migrateclient", { clientIds: checkedIds.toString(), userId: userId, sourceUserId: sourceUserId, isAllChecked: isAllChecked }, function (result) {
                if (result.success) {
                    $("#migrate-client-container").closest("tr").remove();
                    if (window["datatable"] != undefined)
                        datatable.reload();
                    toastr.options.hideDuration = 10000;
                    toastr.options = toastrOptions;
                    toastr.options.positionClass = "toast-top-full-width";
                    toastr.success(result.message);
                    var btn = KTUtil.getById("migrate-btn");
                    KTUtil.btnRelease(btn);
                }
            });
        }
        $(document).on("click", "#migrate-btn", function (e) {
            var btn = KTUtil.getById("migrate-btn");
            KTUtil.btnWait(btn, "spinner spinner-right spinner-white pr-15", "Please wait");
            var userId = $("#adviser-list-drp").val();
            if (checkedIds.length > 0 && userId > 0) {
                var tableContainerId = $(this).closest("table").parent().attr("id");
                var el = $(`#${tableContainerId}`);
                var checkedAll = el.find("#selectedAll").is(":checked");
                var dt = el.KTDatatable();
                var pagination = dt.getDataSourceParam("pagination");
                if (checkedAll || checkedIds.length > pagination.perpage) {
                    var swalOptions = confimationSwalOptions;
                    var dt = el.KTDatatable();
                    var totalRows = dt.getTotalRows();
                    var adviserName = $("#select2-adviser-list-drp-container").text().split("-")[0];
                    swalOptions.html = `This action will move all <span class="text-primary">${totalRows} clients</span> to <span class="text-primary">${adviserName.trim()}</span>.`;
                    swalOptions.confirmButtonText = Message.MoveIt;
                    Swal.fire(swalOptions).then(function (result) {
                        if (result.value)
                            moveClients(checkedIds, userId, sourceUserId, checkedAll)
                    });
                }
                else
                    moveClients(checkedIds, userId, sourceUserId);
            }
        });
        $(document).on("click", "#selectedAllRecords", function (e) {
            var tableContainerId = $(this).closest("table").parent().attr("id");
            var el = $(`#${tableContainerId}`);
            var dt = el.KTDatatable();
            $("#selectAll").toggleClass("d-none");
            $("#onPageRecords").toggleClass("d-none");
            $("#clearSelection").toggleClass("d-none");
            $("#selectedAll").prop("checked", $("#selectAll").hasClass("d-none"));
            el.find(".checkbox-single [type='checkbox']").prop("checked", $("#selectAll").hasClass("d-none"));
            var checked = $("#selectedAll").is(":checked");
            var totalRows = dt.getTotalRows();
            $("#selectedRowsCount").text(totalRows);
            if (!checked) {
                el.find("th .checkbox-all").addClass("checkbox-outline");
                $("#migrate-client-container").closest("tr").remove();
            }
            else
                el.find("th .checkbox-all").removeClass("checkbox-outline");
            setActiveCheckBox(el);
        });
    </script>
}